<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_publication".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPublication".
 *
 * Columns in table "provider_publication" available as properties of the model,
 * followed by relations of table "provider_publication" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $publication_type_id
 * @property string $publisher_name
 * @property string $title
 * @property string $published_year
 * @property string $published_month
 *
 * @property Provider $provider
 */
abstract class BaseProviderPublication extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_publication';
    }

    public static function representingColumn()
    {
        return 'publisher_name';
    }

    public function rules()
    {
        return array(
            array('provider_id, publisher_name, title, publication_type_id', 'required'),
            array('provider_id, publication_type_id, published_year, published_month', 'numerical', 'integerOnly' => true),
            array('publisher_name', 'length', 'max' => 70),
            array('title', 'length', 'max' => 100),
            array('published_year', 'length', 'max' => 4),
            array('published_year', 'numerical', 'min' => 1900, 'max' => date('Y')),
            array('published_month', 'length', 'max' => 2),
            array('published_month', 'type', 'type' => 'date', 'message' => '{attribute} is not valid month (1-12)',
                'dateFormat' => 'M'),
            array('id, provider, publication_type_id, publisher_name, title, published_year, published_month', 'safe',
                'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'publication_type_id' => Yii::t('app', 'Publication Type'),
            'publisher_name' => Yii::t('app', 'Publisher Name'),
            'title' => Yii::t('app', 'Title'),
            'published_year' => Yii::t('app', 'Published Year'),
            'published_month' => Yii::t('app', 'Published Month'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        //$criteria->compare('provider.first_last', $this->provider, true);
        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.first_last", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('publication_type_id', $this->publication_type_id);
        $criteria->compare('publisher_name', $this->publisher_name, true);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('published_year', $this->published_year, true);
        $criteria->compare('published_month', $this->published_month, true);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria,
            'pagination' => array('pageSize' => 100)));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPublication|ProviderPublications', $n);
    }

}
